-- ------------------------------------------------------------
-- Initialization phase

-- Define our custom particle properties
pVelocity = Allocate(2) ; -- Allocate a Vec2 velocity member
pAge = Allocate(1) ; -- Allocate a TReal age member
pSpin = Allocate(1); -- Allocate a TReal spin member
pSpinSpeed = Allocate(1);
-- dLocus is a data source: An external connection to the particle
-- system. Here we define dLocus for FluidFX, since FluidFX doesn't know
-- to provide the data source; in the game it's defined in 
-- swarm.cpp as a data source, and it gets the mouse position.
if not dPos then
   dPos= Vec2(0,0) ;
end

if not dScale then
   dScale = 2;
end

if not dColor then
   dColor = Color(1,0.5,0.5,1);
end
-- Set the particle texture
SetTexture("dust");

-- Set the blend mode
SetBlendMode(kBlendAdditiveAlpha);

-- LAST, we set the total number of particles in the particle
-- system. This doesn't 'create' the particles, but rather
-- allocates a block of 'dead' particles that can be created
-- below.
SetNumParticles(15);    

-- ------------------------------------------------------------
-- Action Phase

-- Particle Initialization Rules.
-- 
-- The following rules define how particles are created.
--
-- Any parameter below in initialization or animation rules that 
-- is a scalar, Color(), or Vec2() can alternaly take a function 
-- that returns the same type--and most functions can take any type
-- and will return that same type. The exception is any function
-- that's expecting a scalar in certain parameter positions.

-- Pick one of two positions randomly, and add dPos.
-- dPos is defined in swarm.cpp and added to the random
-- range

-- Start initial rotation as a random angle
pSpin:Init( fRange( 0, -3.14) );
pSpinSpeed:Init( fRange( pSpin, 3.14) ); 

pPosition:Init( dPos + f2dRotation(pSpin) * fRange(dScale * 2 , dScale * 15) );

-- Pick a velocity from a range
pVelocity:Init( f2dRotation( pSpin) * fRange(dScale * 5, dScale * 15));

-- Start color (tint) off as white (natural color of image)
pColor:Init( Color(1,1,1,1) );

-- Start scale out as 0.5
pScale:Init( dScale );

-- Start age as 0 milliseconds
pAge:Init(0);

pUp:Init( f2dRotation( pSpin ) );

-- Start spin velocity random from -10 to 10

-- ------------------------------------------------------------
-- Particle Parameter Animation Functions
--
-- The following rules define how particles animate.
-- Each rule is applied on each frame of animation.

-- Add velocity scaled by time to position
pPosition:Anim( pPosition + fTimeScale( pVelocity));

pScale:Anim( pScale + fTimeScale(1) );
pVelocity:Anim( pVelocity + fTimeScale(Vec2(0,-5)) );
pColor:Anim( fFade( pAge, dColor, 2000, Color(0,0,0,0) ) );
-- pSpin:Anim( pSpin + fTimeScale( 3.14 ) * 0.2 );
-- pUp:Anim(  fFade( pAge,f2dRotation( 0), 1000, f2dRotation( 3.147) ) );

-- Add time to the age
pAge:Anim( pAge+fAge() );

-- Expire particles over 1500 ms old
Anim( fExpire( fGreater(pAge,4000) ) );

-- Create an initial particle (optional)
-- CreateParticles( 1 );

-- A global variable that we can set from outside
gActive = false;

-- A function to run as we're executing
-- seconds - how many seconds have elapsed
function Update(seconds)
   if gActive then
      -- Create 10 particles per second
      CreateParticles(15 );
   end
end

